#include <systemc.h>


//enum Operationt { Op0, Op1, Op2};
//enum Statet  { Ini, Idle, Busy0A, Busy0B, Busy1, Busy2};

#define Op0 0
#define Op1 1
#define Op2 2

#define Ini 0
#define Idle 1
#define Busy0A 2
#define Busy0B 3
#define Busy1  4
#define Busy2  5

#define Statet int
#define Operationt int

SC_MODULE(Modelt)
{
       sc_clock clk;
       static bool locked;
       static Operationt op;

       static Statet state;

	void client0(){
		if(!locked){
			op = Op0;
      locked = true;
		}
	}

	void client1(){
		if(!locked){
			op = Op1; 
      locked = true;
		}
	}

	void server() {
		switch(state){
			case Ini: {state = Idle; break;}
			case Idle: {
				if(!locked) break;
				switch(op) {
					case Op0:
					{ state = Busy0A; break; }
					case Op1:
					{ state = Busy1; break; }
					default: break;
				}
        
				break;
			}
			case Busy0A:
      { state = Busy0B;
        break;
      }
			case Busy0B: { state = Idle; locked = false; break;}
			case Busy1:
			{ state = Idle; locked = false; break;}
		}
	}

	SC_CTOR(Modelt) {
		SC_METHOD(client0); sensitive << clk;
		SC_METHOD(client1); sensitive << clk;
		SC_METHOD(server);  sensitive << clk;
	}
};


int sc_main(int argc, char* argv[])
{
	Modelt m("");
	m.locked = false;
  int time;
  std::cin >> time;
	sc_start(time);
}
