#include <systemc.h>
#include <iostream>


SC_MODULE(Modt)
{
  sc_clock clk;
  sc_mutex mutex;
  int data;


  void p1()
  {
    while(true)
    {
      mutex.lock();
      std::cout << "P1 enters critical section\n";
      data = 1;
      wait();
      mutex.unlock();
      std::cout << "P1 exits critical section\n";
      wait();
    }
  }

  void p2()
  {
    while(true)
    {
      mutex.lock();
      data = 2;
      std::cout << "P2 enters critical section\n";
      wait();
      mutex.unlock();
      std::cout << "P2 exits critical section\n";
      wait();
    }
  }

  void p3()
  {
    while(true)
    {
      mutex.lock();
      data = 3;
      std::cout << "P3 enters critical section\n";
      wait();
      mutex.unlock();
      std::cout << "P3 exits critical section\n";
      wait();
    }
  }

  SC_CTOR(Modt)
  {
    SC_CTHREAD(p1,clk);
    SC_CTHREAD(p2,clk);
    SC_CTHREAD(p3,clk);
  }
};

int sc_main(int argc, char* argv[])
{
  Modt m("mod");
  int time;
  std::cin >> time;
  sc_start(time);
}
