#!/bin/bash
#
# Author: Nicolas Blanc
#
# Simple script to run an experiment and generate runtime plots.
#
# Usage: sim_time
#
# Example: fsm1$ ../run.sh 10
#

if [ ! $# == 1 ]; then
	echo "One parameter expected but got $#."
	exit
fi

echo $1 | grep "[^0-9]" > /dev/null 2>&1

if [ "$?" == "0" ]; then
	echo "Got \`$1' but expected a number."
	exit
fi



ok1=1
ok2=1

sim_time=$1
date=`date +Date-%d-%m-%y-Time-%H-%M-%S`
logfile="stats."$date".log"
time_out=600
sim1=./scoot_exhaustive_sim-satabs
sim2=./scoot_exhaustive_sim-light

echo "#Cycle Transistions Traces Time Transitions Traces Time" > $logfile

for i in $(seq 1 2 $sim_time)
do
	echo $i
	echo -n "$i " >> $logfile
	if [ $ok1 -eq 1 ]; then
		str1=`timeout $time_out scoot_explorer " echo \"$i\" | $sim1 $i > /dev/null"`
		if [ ! $? -eq 0 ]; then
			ok1=0
		fi
	fi
	echo $str1
	if [ $ok1 -eq 1 ]; then
		str1=`echo "$str1" | sed "s/Transitions: //"`
		str1=`echo "$str1" | sed "s/Traces: //"` 
		str1=`echo "$str1" | sed "s/Seconds: //"`
		echo -n "$str1" >> $logfile
	else
		echo -n "- - -" >> $logfile
	fi
	echo -n " " >> $logfile
	if [ $ok2 -eq 1 ]; then
		str2=`timeout $time_out scoot_explorer " echo \"$i\" | $sim2 $i > /dev/null"`
		if [ ! $? -eq 0 ]; then
			ok2=0
		fi
	fi
	echo $str2
	if [ $ok2 -eq 1 ]; then
		str2=`echo "$str2" | sed "s/Transitions: //"` 
		str2=`echo "$str2" | sed "s/Traces: //"` 
		str2=`echo "$str2" | sed "s/Seconds: //"`
		echo -n "$str2" >> $logfile
	else
		echo -n "- - -" >> $logfile
	fi
	echo "" >> $logfile
done
cat ../gnuplot-run | sed "s/DATE/$date/g" | gnuplot

