#! /bin/bash
#
# Author: Nicolas Blanc
#
# Simple script to generate the strenghtening plots
#
# Example: fsm1/$  ../strengthening_time.sh
#

date=`date +Date-%d-%m-%y-Time-%H-%M-%S`
Jobs=`ls -d job?`

echo $Jobs
for i in $Jobs
do
	cd $i
	if [ -e cbmc_wp.log ]; then
		grep "#STRENGTHENING_ITERATION:" cbmc_wp.log | sed "s/#STRENGTHENING_ITERATION: //" | sed "s/TIME //" > "../strengthening-time.cbmc.$i.$date.log" 
		cat "../../gnuplot-strengthening-time" | sed "s/JOB/$i/g" | sed "s/INFILE/..\/strengthening-time.cbmc.$i.$date.log/g" | sed "s/OUTFILE/..\/strengthening-time.cbmc.$i.$date.eps/g" | sed "s/TITLE/CBMC/g" |  sed "s/COLOR/#00FF00/g" | gnuplot
	fi
	if [ -e satabs_wp.log ]; then
		grep "#STRENGTHENING_ITERATION:" satabs_wp.log | sed "s/#STRENGTHENING_ITERATION: //" | sed "s/TIME //" > "../strengthening-time.satabs.$i.$date.log"
		cat "../../gnuplot-strengthening-time" | sed "s/JOB/$i/" | sed "s/INFILE/..\/strengthening-time.satabs.$i.$date.log/g" | sed "s/OUTFILE/..\/strengthening-time.satabs.$i.$date.eps/g" | sed "s/TITLE/SatAbs/g" | sed "s/COLOR/#FF0000/g" | gnuplot
	fi
	cd ..
done

