#!/bin/bash
#
# Author: Nicolas Blanc
#
# Script to compile the benchmarks
#
#

examples="aes128 aes192 des fft-fxpt fir fir-rtl risc-cpu"
logfile="compiletime."`date +Date-%d-%m-%y-Time-%H-%M-%S`".log"

echo "Example scoot_out.cpp scoot_sim systemc_sim" > $logfile

for i in $examples
do
	cd $i
	echo -n "$i " >> ../$logfile
	make clean
	/usr/bin/time -f "%e"  -o ../comp_time.tmp make scoot_out.cpp
	tmp=`cat ../comp_time.tmp`
	echo -n "$tmp " >> ../$logfile
	/usr/bin/time -f "%e"  -o ../comp_time.tmp make scoot_sim
	tmp=`cat ../comp_time.tmp`
	echo -n "$tmp " >> ../$logfile
	/usr/bin/time -f "%e"  -o ../comp_time.tmp make systemc_sim
	tmp=`cat ../comp_time.tmp`
	echo -n "$tmp " >> ../$logfile
	echo "" >> ../$logfile
	cd ..
done
rm comp_time.tmp
