#!/bin/bash
#
#  Author: Nicolas Blanc
#
#  Script to run the benchmarks
#

examples="aes128 aes192 des fft-fxpt fir fir-rtl  risc-cpu"
date=`date +Date-%d-%m-%y-Time-%H-%M-%S`
logfile="runtime."$date".log"
echo "Benchmark Scoot SystemC" > $logfile

first=1
for example in $examples
do
	cd $example
	echo -n "$example	" >> ../$logfile
	(/usr/bin/time -f "%e"  -o  ../run_time.tmp  ./scoot_sim) > out.scoot
	tmp=`cat ../run_time.tmp`
	echo -n "$tmp " >> ../$logfile
	(/usr/bin/time -f "%e"  -o ../run_time.tmp ./systemc_sim) > out.sysc
	tmp=`cat ../run_time.tmp`
	echo -n "$tmp " >> ../$logfile
	echo "" >> ../$logfile
	diff out.scoot out.sysc
        cd ..
done
cat gnuplot-run | sed "s/DATE/$date/" | gnuplot
