/*******************************************************************\
 *
 *
 * Author: Blanc Nicolas
 *
 * 
\*******************************************************************/


#ifndef __PRINT_H
#define __PRINT_H

#include <__bv.h>
#include <iostream>


inline void __scoot_read_char(const __signedbv<INT_BSIZE>& io,  __signedbv<8>* c)
{
  if(io.to_int() == 0)	// cin
  {
    char tmp;
    std::cin >> tmp;
    *c = __signedbv<8>(tmp);
  }
  else
  {
    assert(0); // input stream not implemented!
  }
}


inline void __scoot_read_int(const __signedbv<INT_BSIZE>& io,  __signedbv<INT_BSIZE>* i)
{
  if(io.to_int() == 0)	// cin
  {
    int tmp;
    std::cin >> tmp;
    *i = __signedbv<INT_BSIZE>(tmp);
  }
  else
  {
    assert(0); // input stream not implemented!
  }
}


inline void __scoot_print_cstr(const __signedbv<INT_BSIZE>& io,  const __signedbv<8>* cstr)
{
  if(io.to_int() == 0)	// cout
  {
    while(cstr->to_int() != 0)
    {
      std::cout << (char) cstr->to_int();
      cstr++;
    }
  }
  else if(io.to_int() == 1)  // cerr
  {
    while(cstr->to_int() != 0)
    {
      std::cerr << (char) cstr->to_int();
      cstr++;
    }
  }
}

inline void __scoot_print_char(const __signedbv<INT_BSIZE>& io,  const __signedbv<8>& c)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  (char) c.to_int();
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<  (char) c.to_int();
}

inline void __scoot_print_int(const __signedbv<INT_BSIZE>& io,  const __signedbv<INT_BSIZE>& i)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  i.to_int();
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<  i.to_int();
}

inline void __scoot_print_unsigned(const __signedbv<INT_BSIZE>& io,  const __unsignedbv<UINT_BSIZE>& i)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  (unsigned) i.to_int();
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<  (unsigned) i.to_int();
}

inline void __scoot_print_long_long(const __signedbv<INT_BSIZE>& io,  const __signedbv<LONG_LONG_INT_BSIZE>& i)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  *((const long long*) i.data);
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<   *((const long long*) i.data);
}

inline void __scoot_print_unsigned_long_long(const __signedbv<INT_BSIZE>& io,  const __unsignedbv<LONG_LONG_UINT_BSIZE>& i)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  *((const unsigned long long*) i.data);
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<   *((const unsigned long long*) i.data);
}



inline void __scoot_print_bool(const __signedbv<INT_BSIZE>& io,  bool b)
{
  if(io.to_int() == 0)	// cout
  {
    std::cout <<  (unsigned) b;
  }
  else if(io.to_int() == 1)  // cerr
    std::cerr <<  (unsigned) b;
}


#endif
